//   TEST FUNCTION FOR PCLP MACRO : FULL MATRICES
//       VERSION WITH MULTIPLE CORRECTOR STEPS
clear 

getf('pclpm.sci');
getf('concats.sci');

n=100;
// p=  round(n/2);
p=3;

e = 0.01

spar=-1
if spar > 0 then
// Sparse matrices
  den=0.01; A = sprand(p,n,den);
  a=rand(p,1);
  for i=1:p, A(i,i) = a(i); end; 
else
// Dense matrices
  A = rand(p,n);
end;

  x = rand(n,1);
  s = rand(n,1);
  xi=x;
  si=s;

  b = A*x;
  c = s ;
  l = zeros(p,1); 

   minf = 1e-10;
   km=300;

  x=ones(n,1);
x = norm(b) * x;
  s=ones(n,1);

  m=x'*s/n;
  redlin = 1;
  verbose= 0;
//
for redlin=0:1
  for typea=1:2 
    if typea==1 then A1=full(A); else A1=sparse(A); end;
    for factor =0:1;
    disp('redlin, typea,factor',redlin, typea,factor)
//
[xn,sn,ln,mn,kiter,kfact,klin]=pclpm(A,b,c,x,s,km,minf,e,redlin,factor,verbose);

// Check optimality:

minxn = min(xn)

minsn = min(sn)

xnsnoverm = xn'*sn / n

primalfeas = norm(A*xn-b)

// norm(c + A'*ln + H*xn - sn)
dualfeas = norm(c + A'*ln  - sn)

disp('Number of major iterations, factorizations, linear systems solved');

dispac = concats(string(kiter),'  ');
dispac = concats(dispac, concats(string(kfact),'  '));
dispac = concats(dispac, string(klin));
disp(dispac);


    end
  end
end



// EOF



